/*
 * Arduino - Processingシリアル通信
 * Arduino側
 * センサーの数（可変パージョン）
 */
 
#define N 4 // センサーの数(複数使用する場合には変更）

int sensors[N]; // センサーの値を格納する配列
int readByte; // 受信するシリアル通信の文字列
void estCon(); // Processing側との通信用関数（ユーザ定義）

// 定義関係
void setup(){
// 初期設定（シリアル通信関係）
  Serial.begin(9600);  // シリアル通信の速度を9600bpsに指定

// 初期設定（センサー関係）
// センサーの値と受信する文字列を初期化
// センサーの値を初期化し，Processing側から送られてくる開始用文字列を初期化する
// この措置はArduino側とProcessing側との通信でデータの衝突がないようにするため行っている．
  for(int i = 0; i<N; i++){
    sensors[i] = 0; // センサーの初期化（複数ある場合は複数初期化される）
  }
  readByte = 0; // 通信開始用文字列の初期化

// 以下の関数を実行することで通信を開始する
estCon();
}


// メイン部分（ここではloop()内に記載された命令を繰り返し行う）
void loop(){


  if (Serial.available() > 0) {
    // 受信した文字列を読み込み
    readByte = Serial.read();
    // アナログセンサーの値を計測
    for(int i = 0; i<N; i++){
      sensors[i] = analogRead(i);
      // コンマ区切りでセンサーの値を送出
      Serial.print(sensors[i]);
      if(i < N - 1){
        Serial.print(",");
      }
      else {
        Serial.print('\n');
      }
    }
  }
}
 
void estCon() {
  // Processingから何か文字が送られてくるのを待つ
  while (Serial.available() <= 0) {
    // 初期化用の文字列
    Serial.println("0,0");
    delay(300);
  }
}
