import processing.serial.*;

int NUM = 4;		// センサの数
Serial myPort;	// シリアルポート


int retsu = 5;

int[] sensors = new int[NUM];
int cnt;
int checked=0;
int bgjud=0;
int menujud=0;

int ichi_onflag=0;
int ni_onflag=0;
int san_onflag=0;
int yon_onflag=0;
int csv_ichi_onflag=0;
int csv_ni_onflag=0;
int csv_san_onflag=0;
int csv_yon_onflag=0;
int dummy=0;

int menutwojunbi = 0;

int pp_flag=0;
int check_flag=0;
int autocheckmode=0;
int saveTableFlag=0;
int captureFlag=0;

int playing_now=1;
float drawcount=0.00;

float regisutansu = 0;

char keydata = ' ';

float currentDrawCount = 0.00;

String sdrawcount="0.00";
String sbunatsu;

String sanalog4 = new String();
String loadPath = null;
String currentPath=null;

color[] col = new color[7];
PImage bg_title;
PImage bg[] = new PImage[16];
PImage fsw[] = new PImage[9];
PImage viewa[] = new PImage[4];
PImage voltMtr;
PImage checkStr;
PImage checkStr_off;
PImage voltagediv;
PImage mgcsvbg;
PImage mgcsvbg_area;
float[][] storage = new float[4][800];
float[][] x_storage = new float[4][800];
Table table;


float tx1tmp = 90;
float ty1tmp = 444;
float tx2tmp = 90;
float ty2tmp = 444;
float tx3tmp = 90;
float ty3tmp = 444;
float tx4tmp = 90;
float ty4tmp = 444;

int kaiten = 0;

float bunatsuteikou = 4700;

//PImage btn01;
 
void setup() {
  size(800, 494);	// ウィンドウサイズ
  frameRate(50);		// フレームレート
  bg_title = loadImage("measurement_tmenu.png");	// タイトル画面の画像を読み込み、bg_titleに格納
  bg[0] = loadImage("bg_off.png");					// Measuring Mode 全てOFFの時の画像
  for(int tp=1;tp<=15;tp++){
    bg[tp] = loadImage("bg_on_"+tp+".png");			// Measuring Mode どれかがONの時の画像
  }


  for(int tp=0;tp<9;tp++){  
    fsw[tp] = loadImage("fbtn_"+tp+".png");			// ボタン画像を読み込み
  }
  for(int tp=0;tp<4;tp++){
    viewa[tp] = loadImage("view"+tp+".png");			// 電圧の数値表示部用の画像を読み込み
  }
    
  checkStr = loadImage("checkmode.png");			// check mode文字画像の読み込み
  checkStr_off = loadImage("checkmode_off.png");	// check modeをOFFにしたとき、文字を消去するための背景画像
  voltagediv = loadImage("voldiv.png");				// 分圧入力の小窓の画像
  mgcsvbg = loadImage("mesbgcsv.png");
  mgcsvbg_area = loadImage("mesbgarea.png");
  
  table = new Table();
  sbunatsu = new String();
  
  table.addColumn("count");
  table.addColumn("value1");
  table.addColumn("value2");
  table.addColumn("value3");  
  table.addColumn("value4");

  
  println(Serial.list());								// シリアルポートのリスト取得
  myPort = new Serial(this, Serial.list()[32], 9600);	// ポート番号とスピードを指定してシリアルポートをオープン
  myPort.bufferUntil('\n');							// 改行コード(\n)が受信されるまで、シリアルメッセージを受ける
  initGraph();											// グラフ初期化関数を実行
    
  strokeWeight(2.0);									// 線の太さを2.0に設定
  strokeCap(ROUND);									// 線の両端を丸っこくする
  strokeJoin(ROUND);									// 線同士をつなげるときも丸っこくする
}
 
void draw() {
  if(menujud==0){				// メニュー画面でなにも押されていない状態
     background(bg_title);	// 背景画像をbg_titleにセット
  }
  else if(menujud==1){			// Measuring Modeが押されたら
    if(bgjud==0){				// 測定ON/OFFボタンがすべてOFFのとき
      background(bg[0]);		// OFF用の画像を読み込み
    }
    else if(playing_now==1){		// 測定ON/OFFがどれかONになったとき
     draw_graph();				// グラフ描画
    }
  }
  else if(menujud==2){   
    if(loadPath == null){
      loadPath = currentPath;		// ファイルが読み込まれていない時の処理
    }
    else{
      String ext = loadPath.substring(loadPath.indexOf('.') + 1);	// ファイルの拡張子だけ取り出す
      if(ext.equals("csv")){
        currentPath=loadPath;		// 拡張子がcsvならデータ読み込み
      }
    }
    if(currentPath != null){
      draw_csv();					// 準備が整ったらグラフ描画
    }
  }
}

// Measuring Mode
void draw_graph(){
  // テキストの基本座標を右、ベースラインに調整
  textAlign(RIGHT, BASELINE);

  //アナログ1がON状態の場合のみ動作
  if(ichi_onflag==1){
    stroke(col[0]);	// グラフの線の色を定義
    float tx1 = map(cnt, 0, width, 90, width-20);	// グラフ描画枠（横幅）に収まるようx座標を決定
    float ty1 = map(sensors[0], 0, 1023, height-50, 144);　// センサ値をy座標値に変換
    line(tx1tmp, ty1tmp, tx1, ty1);	// 1つ前の座標（初期値=(99, 444)）から上記で決めたx,y座標まで線を引く
    
    tx1tmp = tx1;	// 現在のx座標値を代入
    ty1tmp = ty1;	// 現在のy座標値を代入
    
    float analog1 = abs(ty1 - 444) / 62;	// 座標値から電圧値に変換
    storage[0][int(tx1)] = analog1;		// 電圧値をストレージに保存
    
    String sanalog1 = nf(analog1, 1, 2);	// 数値（電圧）から文字に変換

    image(viewa[0], 228, 117);				// 数値表示部の画像を表示
    fill(255);								// フォント色を白に設定
    textSize(18);							// フォントサイズを18に設定
    text(sanalog1, 326, 138);				// 電圧値を表示

    TableRow newRow = table.addRow();		// テーブルに新しい行を追加
    newRow.setString("count", sdrawcount);	// count値（経過秒数）を1列目に格納
    newRow.setString("value1", sanalog1);	// 電圧値を2列目に格納
  }
  
  // アナログ2がON状態の場合のみ動作
  // 上のプログラムと同じ動作をするため、一部を除きコメント省略
  if(ni_onflag==1){
    stroke(col[1]);
    float tx2 = map(cnt, 0, width, 90, width-20);
    float ty2 = map(sensors[1], 0, 1023, height-50, 144);
    line(tx2tmp, ty2tmp, tx2, ty2);
    
    tx2tmp = tx2;
    ty2tmp = ty2;

    float analog2 = abs(ty2 - 444) / 62;
    storage[1][int(tx2)] = analog2;
    
    String sanalog2 = nf(analog2, 1, 2);

    image(viewa[1], 366, 117);
    fill(255);
    textSize(18);
    text(sanalog2, 464, 138);

	// アナログ1がON状態のとき、空セルができる謎事件を防ぐ
    if(ichi_onflag==0){
      TableRow newRow = table.addRow();
      newRow.setString("count", sdrawcount);
      newRow.setString("value2", sanalog2);		// 電圧値を3列目に格納
    }
    else{
      TableRow insertRow2 =table.getRow(cnt);
      insertRow2.setString("value2", sanalog2);	// 電圧値を3列目に格納
    }
  }
  
  if(san_onflag==1){
    stroke(col[2]);
    float tx3 = map(cnt, 0, width, 90, width-20);
    float ty3 = map(sensors[2], 0, 1023, height-50, 144);
    line(tx3tmp, ty3tmp, tx3, ty3);
    
    tx3tmp = tx3;
    ty3tmp = ty3;
    
    
    float analog3 = abs(ty3 - 444) / 62;
    storage[2][int(tx3)] = analog3;
    
    String sanalog3 = nf(analog3, 1, 2);

    image(viewa[2], 504, 117);
    fill(255);
    textSize(18);
    text(sanalog3, 602, 138);

    if(ichi_onflag==0 && ni_onflag==0){
      TableRow newRow = table.addRow();
      newRow.setString("count", sdrawcount);
      newRow.setString("value3", sanalog3);
    }
    else{
      TableRow insertRow3 =table.getRow(cnt);
      insertRow3.setString("value3", sanalog3);      
    }
  }
  
  // 抵抗測定
  if(yon_onflag==1){
    stroke(col[3]);
    float tx4 = map(cnt, 0, width, 90, width-20);
    float ty4 = map(sensors[3], 0, 1023, height-50, 144);
    line(tx4tmp, ty4tmp, tx4, ty4);
    
    tx4tmp = tx4;
    ty4tmp = ty4;
    
    float analog4 = abs(ty4 - 444) / 62;	// 電圧値
    regisutansu = (bunatsuteikou * analog4) / (5 - analog4); // 分圧の計算より抵抗値の導出
    
    if(regisutansu < 1){
      sanalog4 = "No Input"; // 抵抗値が1以下なら未入力とする
    }
    else if(regisutansu >= 1000){
      float regisutansu_k = regisutansu / 1000;
      sanalog4 = nf(regisutansu_k, 1, 1) + "k"; // 抵抗値が1000以上なら、抵抗値を1000で割り「ｋ」を表示
    }
    else if(regisutansu >= 1000000){
      float regisutansu_m = regisutansu / 1000000;
      sanalog4 = nf(regisutansu_m, 1, 1) + "M"; // 抵抗値が1000000以上なら、抵抗値を1000000で割り「M」を表示
    }
    else {
      sanalog4 = nf(regisutansu, 1, 1);	// 上記以外ならそのまま表示
    }
    storage[3][int(tx4)] = regisutansu;	// 抵抗値をストレージに格納
    
    String csv_sanalog4 = nf(regisutansu, 1, 1);	// 抵抗値をログ出力用にテキスト変換する

	// 抵抗値表示部
    image(viewa[3], 642, 117);
    fill(255);
    textSize(18);
    text(sanalog4, 740, 138);
	
	// 分圧抵抗変更ボックス
    image(voltagediv, 642, 406);
    textSize(15);
    text(nf(bunatsuteikou, 0, 0), 750, 440);

	// 謎事件
    if(ichi_onflag==0 && ni_onflag==0 && san_onflag==0){
      TableRow newRow = table.addRow();
      newRow.setString("count", sdrawcount);
      newRow.setString("value4", csv_sanalog4);
    }
    else{
      TableRow insertRow4 =table.getRow(cnt);
      insertRow4.setString("value4", csv_sanalog4);      
    }
  }
  
  // キャプチャボタンを押したときに、個人的な趣味によりボタンを0.4秒だけ押した感じに変えるちょっとややこしいやつ
  if (captureFlag == 1){
    if(drawcount > currentDrawCount +0.4){
        image(fsw[7], 626, 457);
        captureFlag=0;
     }
  }
  
  // cntが800を超えたら
  if (cnt > width) {
	// Auto stop & CheckがONになっていたらキャプチャとログを出力する
    if(autocheckmode==1){

        saveFrame("capture_"+year()+"-"+month()+"-"+day()+"-"+hour()+"-"+minute()+"-"+second()+".png");
        saveTable(table, "data_"+year()+"-"+month()+"-"+day()+"-"+hour()+"-"+minute()+"-"+second()+".csv");
      
      autoStopCheck();
    }  
	
	// Export to .CSV Fileが押されていたらログを出力する
    if(saveTableFlag==1){

        saveTable(table, "data_"+year()+"-"+month()+"-"+day()+"-"+hour()+"-"+minute()+"-"+second()+".csv");

    }
	
	// キャプチャボタンを押したときに、個人的な趣味によりボタンを0.4秒だけ押した感じに変えるちょっとややこしいやつの例外処理
    if (captureFlag == 1){
       image(fsw[7], 626, 457);
        captureFlag=0;
    }

    if(autocheckmode==0){
      initGraph();	// いろいろリセット
    }
  }
  cnt++;
  drawcount=drawcount+0.02;	// 1フレーム分、秒を加算
  sdrawcount = nf(drawcount, 1, 2);	// 数値を文字に変換
  
  fill(17);	// 設定色を濃い灰色にする

  rect(720, 165, 50, 20);		// 座標(720, 165)に50px×20pxの矩形を描く
  fill(255);  					// 設定色を白にする
  textSize(13);				// フォントサイズを13にする
  text(sdrawcount, 768, 180);	// 経過秒数を表示
}

// Browse Mode
void draw_csv(){
  textAlign(RIGHT, BASELINE);

  int xcnt = 0;
  int xcnt_st = 0;
  
  image(mgcsvbg_area, 90, 144);	// 描画エリアの画像を読み込み


  String csvfile[] = loadStrings(currentPath);	// csvファイルをテーブルに格納
  
  String[][] csv_vdata = new String[csvfile.length][retsu];	// 電圧のデータをいれる配列を定義
  
  for(int i=0;i < csvfile.length; i++){
    String csvtemp[] = split(csvfile[i], ",");				// カンマでくぎっていったん予備に移動
    for(int j=0; j < csvtemp.length; j++){
      csv_vdata[i][j] = csvtemp[j];						// 予備に移動したものをストレージに格納
    }
  }
  
  if(csv_vdata[1][1] != ""){
    csv_ichi_onflag = 1;		// csvの2列目にデータがはいっていたら，アナログ1をONにする
  }
  if(csv_vdata[1][2] != ""){
    csv_ni_onflag = 1;			// csvの3列目にデータがはいっていたら，アナログ2をONにする
  }
  if(csv_vdata[1][3] != ""){
    csv_san_onflag = 1;			// csvの4列目にデータがはいっていたら，アナログ3をONにする
  }

  float[][] zdata_x = new float[csvfile.length-1][retsu-1];		// x座標値を格納する配列を定義する
  float[][] zdata_y = new float[csvfile.length-1][retsu-1];  	// y座標値を格納する配列を定義する


  for(int i=1;i < csvfile.length; i++){
    for(int j = 1; j < retsu; j++){
      x_storage[j-1][int(map(xcnt_st, 0, width, 90, width-20))] = float(csv_vdata[i][j]);		// 座標値を電圧値に変換してストレージに格納
    }
    xcnt_st++;
  }
  
  



  
  for(int i=1;i < csvfile.length; i++){
    for(int j = 1; j < retsu; j++){
      zdata_x[i-1][j-1] = map(xcnt, 0, width, 90, width-20);		//zdataにx座標データを代入する
      zdata_y[i-1][j-1] = 444-62*(float(csv_vdata[i][j]));		// 電圧値から座標データに変換
    }
    xcnt++;
  }
  
  for(int j = 0; j < 3; j++){
    stroke(col[j]);											// 線を指定の色で描く
    for(int i = 0; i < csvfile.length - 2;i++){
      line(zdata_x[i][j], zdata_y[i][j], zdata_x[i+1][j], zdata_y[i+1][j]);	// 上で保存した座標データをもとにグラフ描画
    }
  }
  
  menutwojunbi = 1;
  

  
}

// Auto Stop and Checkが押された時の動作
void autoStopCheck(){
  autocheckmode=2;				// Auto Stop and Check フラグをON
  image(checkStr, 100, 147);
  image(fsw[1], 0, 457);
  playing_now=0;				// プレイフラグをOFF
  pp_flag=1;					// ポーズフラグをON
}

// グラフ初期化関数
void initGraph() {
  background(bg[bgjud]);		// 背景画像を設定
  noStroke();
  image(fsw[0], 0, 457);
  image(fsw[2], 166, 457);
  image(fsw[3], 284, 457);
  image(fsw[5], 457, 457);
  image(fsw[7], 626, 457);
  
  table.clearRows();			// テーブルをリセット
  saveTableFlag=0;				// テーブル保存フラグをOFF
    drawcount = 0.000;			// カウントをリセット
    sdrawcount="0.000";		// カウント（文字）もリセット

  cnt = 0;						// cntをリセット
  playing_now=1;				// プレイフラグをON
  pp_flag=0;					// ポーズフラグをOFF
  autocheckmode=0;				// Auto Stop and Check フラグをOFF
  check_flag=0;				// チェックモードフラグをOFF
  tx1tmp = 90;					// A0 x座標初期値
  tx2tmp = 90;					// A1 x座標初期値
  tx3tmp = 90;					// A2 x座標初期値
  tx4tmp = 90;					// A3 x座標初期値
  col[0] = color(245, 22, 22);	// A0の色設定
  col[1] = color(122, 245, 22);	// A1の色設定
  col[2] = color(245, 200, 22);	// A2の色設定
  col[3] = color(22, 171, 245);	// A3の色設定
  col[4] = color(127);			// 未使用
  col[5] = color(0);				// 未使用
  col[6] = color(255);			// 未使用
}

// ファイル選択関数
void fileSelected(File selection) {
  if (selection == null) {
   println("Window was closed or the user hit cancel.");	// ウィンドウが閉じられた、キャンセルが押された時の処理
  } 
  else {
    println("User selected " + selection.getAbsolutePath());
    loadPath = selection.getAbsolutePath(); // ファイルの絶対パスをloadPathに格納
  }
}

// マウスがクリックされたときに動作する関数（mouseX>=・・・などのif文は有効なクリック座標範囲を示す）
void mouseClicked() {
  if(menujud==0){
    if(mouseX>=80 && mouseX<=720 && mouseY>=133 && mouseY<=272){
      menujud=1;				// Measuring Mode
    }	
    if(mouseX>=80 && mouseX<=720 && mouseY>=293 && mouseY<=432){
      menujud=2;				// Browse Mode
      background(mgcsvbg); 	//Browse Mode用の背景画像を表示
    }
  }
  
  if(menujud!=0){
    if((mouseX>=55 && mouseX<=270 && mouseY>=35 && mouseY<=85)&bgjud==0){
      if(menujud==2){
        currentPath=null;			// リセット
        loadPath = null;				// リセット
        storage= new float[4][800];	// リセット
      }
       menujud=0;					// リセット
    }
  }
  
  if(menujud==1){
  // 測定ON/OFFボタン「壱」の部分
  if(mouseX>=378 && mouseX<=468 && mouseY>=0 && mouseY<=79){
    // 「壱」がOFFだったら
    if(ichi_onflag==0){
       bgjud+=8;				// bg配列を2進的に変化させる
       initGraph();			// リセット
       ichi_onflag=1;			// 「壱」をON
    }
    // 「壱」がONだったら
    else{
       bgjud-=8;
       initGraph();
       ichi_onflag=0;  		// 「壱」をOFF
    }
  }
  //以下「弐」「参」「四」同様
  if(mouseX>=481 && mouseX<=571 && mouseY>=0 && mouseY<=79){
    if(ni_onflag==0){
       bgjud+=4;
       initGraph();
       ni_onflag=1;
    }
    else{
       bgjud-=4;
       initGraph();
       ni_onflag=0;  
    }
  }
  if(mouseX>=584 && mouseX<=674 && mouseY>=0 && mouseY<=79){
    if(san_onflag==0){
       bgjud+=2;
       initGraph();
       san_onflag=1;
    }
    else{
       bgjud-=2;
       initGraph();
       san_onflag=0;  
    }
  }
  if(mouseX>=687 && mouseX<=777 && mouseY>=0 && mouseY<=79){
    if(yon_onflag==0){
       bgjud+=1;
       initGraph();
       yon_onflag=1;
    }
    else{
       bgjud-=1;
       initGraph();
       yon_onflag=0;  
    }
  }
  
  //チェックモードが有効であれば
  if(autocheckmode==2){
    if(mouseX>=90 && mouseX<=680 && mouseY>=144 && mouseY<=454){

      if(ichi_onflag==1){
        String view_storage1 = nf(storage[0][int(mouseX)], 1, 2);　	// マウス座標をもとにストレージから探し出す
        image(viewa[0], 228, 117);									// 画像読み込み
        fill(255);													// 文字色を白にする
        textSize(18);												// テキストサイズ
        text(view_storage1, 326, 138);      						// テキスト表示
      }
	  //以下同様
      if(ni_onflag==1){
        String view_storage2 = nf(storage[1][int(mouseX)], 1, 2);
        image(viewa[1], 366, 117);
        fill(255);
        textSize(18);
        text(view_storage2, 464, 138);      
      }
      if(san_onflag==1){
        String view_storage3 = nf(storage[2][int(mouseX)], 1, 2);
        image(viewa[2], 504, 117);
        fill(255);
        textSize(18);
        text(view_storage3, 602, 138);      
      }
      if(yon_onflag==1){
        String view_storage4;
        if(storage[3][int(mouseX)] >= 1000){
          view_storage4 = nf(storage[3][int(mouseX)] / 1000, 1, 2) + "k";
        }
        else if(storage[3][int(mouseX)] >= 1000000){
          view_storage4 = nf(storage[3][int(mouseX)] / 1000000, 1, 2) + "M";
        }
        else if(storage[3][int(mouseX)] < 1){
          view_storage4 = "No Input";
        }
        else{
          view_storage4 = nf(storage[3][int(mouseX)], 1, 2);      
        }
        image(viewa[3], 642, 117);
        fill(255);
        textSize(18);
        text(view_storage4, 740, 138);      
      }
    }    
  }
  if(bgjud!=0){ 
	//再開・一時停止の処理
    if(mouseX>=91 && mouseX<=148 && mouseY>=466 && mouseY<=484){
      if(pp_flag==0){
//      image(fsw[1], 0, 457);
        image(fsw[3], 284, 457);
//      playing_now=0;
//      pp_flag=1;
        autoStopCheck();
      }
      else{
        image(fsw[0], 0, 457);
        image(checkStr_off, 100, 147);
        image(fsw[3], 284, 457);
        autocheckmode=0;    
        playing_now=1;
        pp_flag=0;
        check_flag=0;
      }
    }
	// リセットボタンの処理
    if(mouseX>=179 && mouseX<=236 && mouseY>=466 && mouseY<=484){
      initGraph();
    }
  
	// オートモードの処理
    if(mouseX>=305 && mouseX<=442 && mouseY>=466 && mouseY<=484){
      if(check_flag==0){
        image(fsw[4], 284, 457);
        autocheckmode=1;
        check_flag=1;
      }
      else{
        image(fsw[0], 0, 457);
        image(fsw[3], 284, 457);
        autocheckmode=0;
        playing_now=1;
        pp_flag=0;
        check_flag=0;
      }
    }
  
    if(mouseX>=473 && mouseX<=610 && mouseY>=466 && mouseY<=484){
      image(fsw[6], 457, 457);
      saveTableFlag=1;
    }
  } 
  
  // キャプチャボタンの処理
  if(mouseX>=641 && mouseX<=778 && mouseY>=466 && mouseY<=481){
      image(fsw[8], 626, 457);
      currentDrawCount = drawcount;
      captureFlag=1;
      saveFrame("capture_"+year()+"-"+month()+"-"+day()+"-"+hour()+"-"+minute()+"-"+second()+".png");

  }
  }
  

  
  if(menutwojunbi == 1){
    if(mouseX>=90 && mouseX<=680 && mouseY>=144 && mouseY<=454){
      
      if(csv_ichi_onflag == 1){
        String view_storage1 = nf(x_storage[0][int(mouseX)], 1, 2);
        image(viewa[0], 228, 117);
        fill(255);
        textSize(18);
        text(view_storage1, 326, 138);      
      }
      
      if(csv_ni_onflag == 1){
        String view_storage2 = nf(x_storage[1][int(mouseX)], 1, 2);
        image(viewa[1], 366, 117);
        fill(255);
        textSize(18);
        text(view_storage2, 464, 138);      
      }
      
      if(csv_san_onflag == 1){
        String view_storage3 = nf(x_storage[2][int(mouseX)], 1, 2);
        image(viewa[2], 504, 117);
        fill(255);
        textSize(18);
        text(view_storage3, 602, 138);      
      }
    }
  }
  if(menujud == 2){
    if(mouseX>=641 && mouseX<=778 && mouseY>=466 && mouseY<=481){
      if(currentPath!=null){
        currentPath=null;
        loadPath = null;
        storage= new float[4][800];        
      }
      selectInput("Select a .csv file:", "fileSelected");
    }
  }
}

// キーボードに何かしらの入力があった時に実行する関数
void keyPressed()
{
  if(menujud == 1){						// 測定モードのとき
  if(key >= '0' && key <= '9'){			// 押されたキーが数字だったら
    keydata = key;						// 押された数字をkeydata（文字）に格納
    sbunatsu = sbunatsu + keydata;	// 分圧抵抗用の文字変数にkeydata（文字）を追加　
										// （たとえばsbunatsuが「a」でkeydataが「b」なら、この式でsbunatsuが「ab」となる。）
  }
  else if(key == ENTER || key == RETURN){	// ENTERキーがおされたら
    bunatsuteikou = float(sbunatsu);	// 分圧抵抗（文字変数）をfloat型に変換してbunatsuteikouに代入
    sbunatsu = "";						// sbunatsuをリセット
  }
  }
}

// シリアル通信用関数
void serialEvent(Serial myPort) {
  String myString = myPort.readStringUntil('\n');		// シリアルバッファーを読込み
  myString = trim(myString);							// 空白文字などのいらない情報を消す
  sensors = int(split(myString, ','));					// コンマ区切りで複数の情報を読み込む
  myPort.write("A");									// 読み込みが完了したら、次の情報を要求
}
